Bug 60255 - Wrong exception in emulated opcodes
Summary: Wrong exception in emulated opcodes
Status: RESOLVED FIXED
Alias: None
Product: Runtime
Classification: Mono
Component: JIT (show other bugs)
Version: unspecified
Hardware: PC Mac OS
: --- normal
Target Milestone: ---
Assignee: Bugzilla
URL:
Depends on:
Blocks:
 
Reported: 2017-10-18 14:48 UTC by Marek Safar
Modified: 2017-10-27 03:28 UTC (History)
3 users (show)

Tags:
Is this bug a regression?: ---
Last known good build:

Notice (2018-05-24): bugzilla.xamarin.com is now in read-only mode.

Please join us on Visual Studio Developer Community and in the Xamarin and Mono organizations on GitHub to continue tracking issues. Bugzilla will remain available for reference in read-only mode. We will continue to work on open Bugzilla bugs, copy them to the new locations as needed for follow-up, and add the new items under Related Links.

Our sincere thanks to everyone who has contributed on this bug tracker over the years. Thanks also for your understanding as we make these adjustments and improvements for the future.


Please create a new report on GitHub or Developer Community with your current version information, steps to reproduce, and relevant error messages or log files if you are hitting an issue that looks similar to this resolved bug and you do not yet see a matching new report.

Related Links:
Status:
RESOLVED FIXED

Description Marek Safar 2017-10-18 14:48:10 UTC
emul_ldiv and emul_lrem throws the wrong overflow exception

32bit machine

csharp> var c = long.MinValue;
csharp> var d = -1L;
csharp> c / d;
System.ArithmeticException: Overflow or underflow in the arithmetic operation.


64bit machine

csharp> var c = long.MinValue;
csharp> var d = -1L;
csharp> c / d;
System.OverflowException: Arithmetic operation resulted in an overflow.


Expected: Same Overflow exception is thrown
Comment 1 Zoltan Varga 2017-10-26 14:20:55 UTC
https://github.com/mono/mono/pull/5874
Comment 2 Zoltan Varga 2017-10-27 03:28:10 UTC
Fixed in mono master eb9238c05e1b5959993be42cb788480f030b3b34.